//-----------------------------------------------------
// 1wire.h
//-----------------------------------------------------
//-------------------------data pin definition-----------
#define DQ pin_D3

//--------------------------1wire reset-----------------

init_1wire()
{
int a;

output_low(DQ);
delay_us(480);
output_float(DQ);
delay_us(65);
a=!input(DQ);
delay_us(240);
if(a)
return(1);
else
return(0);
}

//---------------------------read byte---------------

byte read_1wire()
{
byte a,data;

for(a=0;a<8;a++)
{
output_low(DQ);
delay_us(15);
output_float(DQ);
delay_us(5);
shift_right(&data,1,input(DQ));
delay_us(100);
}
return(data);
}

//------------------------write byte--------------------

byte write_1wire(byte data)
{
byte a;

for(a=0;a<8;a++)
{
output_low(DQ);
delay_us(10);
if(shift_right(&data,1,0))
output_high(DQ);
else
output_low(DQ);
delay_us(50);
output_high(DQ);
delay_us(50);
}
return(1);
}

