#include <16f877A.h>
#device *=16
#device adc=8  
#fuses HS, NOPROTECT, BROWNOUT, PUT, NOLVP, NOCPD
#use delay (clock=8000000,restart_wdt) //8.00 MHz
#include <1wire.h>
#include <1wire.c>
#include <math.h>
#include <ds1820.c>
#include <flex_lcd.c>  

int i,read_ok;
byte buffer[8];
signed int16 t,t1;
int fTemp=0;
int iWrite=0;
float fTemp1=0;
float fTemp2=0;
void main() 
{ 
	
	float temperature; 
	
	SET_TRIS_B(0x01);
	setup_adc_ports(NO_ANALOGS); 
	setup_adc(ADC_OFF); 
	//setup_psp(PSP_DISABLED); 
	setup_spi(FALSE); 
	setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1
	); 
	setup_timer_1(T1_DISABLED); 
	setup_timer_2(T2_DISABLED,0,1); 
	setup_comparator(NC_NC_NC_NC); 
	setup_vref(VREF_LOW|-2); 
	
	delay_ms(50); 
	
	// The lcd_init() function should always be called once, 
	// near the start of your program. 
	lcd_init(); 
	
	// Clear the LCD. 
	printf(lcd_putc, "\f"); 

	
	while(1) 
	  	{ 
	
	
	if(init_1wire())
	{
	write_1wire(0xcc); //skip ROM
	write_1wire(0x44); //convert T
	}
	if(init_1wire())
	{
	write_1wire(0xcc); //skip ROM
	write_1wire(0xbe); //read scratchpad
	for(i=0;i<8;i++)
	buffer[i]=read_1wire();
	read_ok=1;
	}
	if(read_ok)
	{
	t=make16(buffer[1],buffer[0]); //calculate temperature
	t=(float)t/16.0; //Calculation 0.1 deg C resolution
	
	
	//printf(lcd_putc, "\f"); 
	//printf(lcd_putc, "ok = true");
	fTemp = (int)t/16.0;
	//temperature = (float)t/16.0;
	temperature = (float)(t*20)/16.0;
	fTemp1 = (float)t;
	fTemp2 = (float)t/16.0;
	
	//printf(lcd_putc,"/fOk = true");
	delay_ms(200);
	}
	
	lcd_gotoxy(1,1);
//	printf(lcd_putc,"Temp= %3.1f \uC", t);

	//printf(lcd_putc, "\f"); 
	//printf(lcd_putc,"Temp= %3.1d \uC", fTemp);
	//printf(lcd_putc,"t= %3.2f \uC", fTemp1);
	//lcd_gotoxy(1,2);
	//printf(lcd_putc,"X= %4i \ori", iWrite);
	if(iWrite > 100)
	{
		iWrite = 0;
	}
	lcd_gotoxy(1,1);
printf(lcd_putc,"t/16.0= %3.2f \uC", fTemp2);
	lcd_gotoxy(1,2);
printf(lcd_putc,"(t*20)/16.0= %3.2f", temperature);

	iWrite++;
	//\u displays degree sign
	delay_ms(1000);



	// Test some additional characters. 
	//   printf(lcd_putc, "\fABCDEFGHIJKLMNOP"); 
	//   printf(lcd_putc, "\nabcdefghijklmnop"); 
	//   printf(lcd_putc, "\n1234567890123456"); 
	//   printf(lcd_putc, "\n!@#$^&*(){}[]:;<"); 
	//   delay_ms(3000); 
	
	//printf(lcd_putc, "\fMamy, te iubesc pana");
	//printf(lcd_putc, "\nla Doamne Doamne si ");
	//printf(lcd_putc, "\ninapoi, de un");
	//printf(lcd_putc, "\ninfinit de ori :X:X"); 
	//delay_ms(2000);


// 
//

  	}    

} 



void testing()
{
	int sus=0;
	int i=0;
	int a=0;
	int apasat=0;
	int iSuma=0;

direct:
		if(sus==0 && apasat==0)
		{
				if (INPUT_STATE(PIN_B0) == 0)
				{	
					printf(lcd_putc, "\fNr apasari: %3.1d ", iSuma); 
					delay_ms(100);
					iSuma++;
					apasat=1;
					goto invers;
				}
		}
invers:
			if (apasat==1)
			{
				if (INPUT_STATE(PIN_B0) == 0 && apasat==1)
					{	
					printf(lcd_putc, "\fNr apasari: %3.1d ", iSuma); 
					delay_ms(100);
					iSuma++;
					apasat=0;
					goto direct;
					}
			}
}
